Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/EXP00/namelist_cfg
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/EXP00/namelist_cfg	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/EXP00/namelist_cfg	(revision 8865)
@@ -8,5 +8,5 @@
    rn_dx = 1000.0
    rn_dz = 1.0
-   nn_wad_test = 7
+   nn_wad_test = 1
 /
 !-----------------------------------------------------------------------
@@ -142,6 +142,6 @@
 &nambdy        !  unstructured open boundaries
 !-----------------------------------------------------------------------
-    ln_bdy         = .true.            
-    nb_bdy         = 1                    !  number of open boundary sets
+    ln_bdy         = .false.            
+    nb_bdy         = 0                    !  number of open boundary sets
     ln_coords_file = .false.              !  =T : read bdy coordinates from file
     cn_coords_file = 'coordinates.bdy.nc' !  bdy coordinates files
@@ -394,10 +394,10 @@
 !-----------------------------------------------------------------------
    ln_glo_trd  = .false.   ! (T) global domain averaged diag for T, T^2, KE, and PE
-   ln_dyn_trd  = .true.   ! (T) 3D momentum trend output
+   ln_dyn_trd  = .false.   ! (T) 3D momentum trend output
    ln_dyn_mxl  = .FALSE.   ! (T) 2D momentum trends averaged over the mixed layer (not coded yet)
    ln_vor_trd  = .FALSE.   ! (T) 2D barotropic vorticity trends (not coded yet)
    ln_KE_trd   = .false.   ! (T) 3D Kinetic   Energy     trends
    ln_PE_trd   = .false.   ! (T) 3D Potential Energy     trends
-   ln_tra_trd  = .true.    ! (T) 3D tracer trend output
+   ln_tra_trd  = .false.    ! (T) 3D tracer trend output
    ln_tra_mxl  = .false.   ! (T) 2D tracer trends averaged over the mixed layer (not coded yet)
    nn_trd      = 365       !  print frequency (ln_glo_trd=T) (unit=time step)
@@ -444,17 +444,16 @@
 &namwad  !   Wetting and drying
 !-----------------------------------------------------------------------
-   ln_wd             = .false.  ! T/F activation of NOC  wetting and drying scheme
+   ln_wd             = .false  ! T/F activation of NOC  wetting and drying scheme
    ln_rwd            = .true.   ! T/F activation of ROMS wetting and drying scheme
+   ln_rwd_bc         = .true.
    ln_rwd_rmp        = .true.   ! Turn on the limiter
-   ln_rwd_bc         = .true.   ! ROMS Baroclinic option
    ln_wd_diag        = .false.   ! T/F activation of diagnostics for ROMS wd scheme
-   rn_wdmin0         =  0.50     ! Rmp value for NOCL option
-   rn_wdmin1         =  0.150    ! Minimum wet depth on dried cells
-   rn_wdmin2         =  0.001    ! Tolerance of min wet depth on dried cells
-   rn_ssh_ref        =  3.0     ! reference level
+   rn_wdmin0         =  0.30     ! Minimum wet depth on dried cells
+   rn_wdmin1         =  0.2     ! Minimum wet depth on dried cells
+   rn_wdmin2         =  0.0001  ! Tolerance of min wet depth on dried cells
    rn_wdld           =  2.5     ! Land elevation below which wetting/drying is allowed
    nn_wdit           =   20     ! Max iterations for W/D limiter
    jn_wd_i           =  22      ! i index of diagnostics
    jn_wd_j           =   3      ! j index of diagnostics
-   jn_wd_k           =   3      ! k index of diagnostics
-/
+ 
+/
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/domain.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/domain.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/domain.F90	(revision 8865)
@@ -674,7 +674,7 @@
       ENDIF
       !
-      IF( ln_wd  .or. ln_rwd ) THEN              ! wetting and drying domain
+      !IF( ln_wd  .or. ln_rwd ) THEN              ! wetting and drying domain
+      IF( ln_wd   ) THEN              ! wetting and drying domain
          CALL iom_rstput( 0, 0, inum, 'ht_0'   , ht_0   , ktype = jp_r8 )
-         CALL iom_rstput( 0, 0, inum, 'ht_wd'  , ht_wd  , ktype = jp_r8 )
       ENDIF
       !
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/stpctl.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/stpctl.F90	(revision 8865)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/stpctl.F90	(revision 8865)
@@ -0,0 +1,194 @@
+MODULE stpctl
+   !!======================================================================
+   !!                       ***  MODULE  stpctl  ***
+   !! Ocean run control :  gross check of the ocean time stepping
+   !!======================================================================
+   !! History :  OPA  ! 1991-03  (G. Madec) Original code
+   !!            6.0  ! 1992-06  (M. Imbard)
+   !!            8.0  ! 1997-06  (A.M. Treguier)
+   !!   NEMO     1.0  ! 2002-06  (G. Madec)  F90: Free form and module
+   !!            2.0  ! 2009-07  (G. Madec)  Add statistic for time-spliting
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   stp_ctl      : Control the run
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers variables
+   USE dom_oce         ! ocean space and time domain variables 
+   USE c1d             ! 1D vertical configuration
+   !
+   USE in_out_manager  ! I/O manager
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE lib_mpp         ! distributed memory computing
+   USE lib_fortran     ! Fortran routines library 
+!   USE wet_dry,  ONLY: ln_wd, ln_rwd , rn_ssh_ref    ! reference depth for negative bathy
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC stp_ctl           ! routine called by step.F90
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id: stpctl.F90 6140 2015-12-21 11:35:23Z timgraham $
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE stp_ctl( kt, kindic )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE stp_ctl  ***
+      !!                     
+      !! ** Purpose :   Control the run
+      !!
+      !! ** Method  : - Save the time step in numstp
+      !!              - Print it each 50 time steps
+      !!              - Stop the run IF problem ( indic < 0 )
+      !!
+      !! ** Actions :   'time.step' file containing the last ocean time-step
+      !!                
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in   ) ::   kt       ! ocean time-step index
+      INTEGER, INTENT(inout) ::   kindic   ! error indicator
+      !!
+      INTEGER  ::   ji, jj, jk             ! dummy loop indices
+      INTEGER  ::   ii, ij, ik             ! local integers
+      REAL(wp) ::   zumax, zsmin, zssh2, zsshmax    ! local scalars
+      INTEGER, DIMENSION(3) ::   ilocu     ! 
+      INTEGER, DIMENSION(2) ::   ilocs     ! 
+      !!----------------------------------------------------------------------
+      !
+      IF( kt == nit000 .AND. lwp ) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'stp_ctl : time-stepping control'
+         WRITE(numout,*) '~~~~~~~'
+         ! open time.step file
+         CALL ctl_opn( numstp, 'time.step', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp, narea )
+      ENDIF
+      !
+      IF(lwp) WRITE ( numstp, '(1x, i8)' )   kt      !* save the current time step in numstp
+      IF(lwp) REWIND( numstp )                       !  --------------------------
+      !
+      !                                              !* Test maximum of velocity (zonal only)
+      !                                              !  ------------------------
+      !! zumax = MAXVAL( ABS( un(:,:,:) ) )                ! slower than the following loop on NEC SX5
+      zumax = 0.e0
+      DO jk = 1, jpk
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zumax = MAX(zumax,ABS(un(ji,jj,jk)))
+          END DO 
+        END DO 
+      END DO        
+      IF( lk_mpp )   CALL mpp_max( zumax )                 ! max over the global domain
+      !
+      IF( MOD( kt, nwrite ) == 1 .AND. lwp )   WRITE(numout,*) ' ==>> time-step= ',kt,' abs(U) max: ', zumax
+      !
+      IF( zumax > 20.e0 ) THEN
+         IF( lk_mpp ) THEN
+            CALL mpp_maxloc(ABS(un),umask,zumax,ii,ij,ik)
+         ELSE
+            ilocu = MAXLOC( ABS( un(:,:,:) ) )
+            ii = ilocu(1) + nimpp - 1
+            ij = ilocu(2) + njmpp - 1
+            ik = ilocu(3)
+         ENDIF
+         IF(lwp) THEN
+            WRITE(numout,cform_err)
+            WRITE(numout,*) ' stpctl: the zonal velocity is larger than 20 m/s'
+            WRITE(numout,*) ' ====== '
+            WRITE(numout,9400) kt, zumax, ii, ij, ik
+            WRITE(numout,*)
+            WRITE(numout,*) '          output of last fields in numwso'
+         ENDIF
+         kindic = -3
+      ENDIF
+9400  FORMAT (' kt=',i6,' max abs(U): ',1pg11.4,', i j k: ',3i5)
+      !
+      !                                              !* Test minimum of salinity
+      !                                              !  ------------------------
+      !! zsmin = MINVAL( tsn(:,:,1,jp_sal), mask = tmask(:,:,1) == 1.e0 )  slower than the following loop on NEC SX5
+      zsmin = 100._wp
+      DO jj = 2, jpjm1
+         DO ji = 1, jpi
+            IF( tmask(ji,jj,1) == 1) zsmin = MIN(zsmin,tsn(ji,jj,1,jp_sal))
+         END DO
+      END DO
+      IF( lk_mpp )   CALL mpp_min( zsmin )                ! min over the global domain
+      !
+      IF( MOD( kt, nwrite ) == 1 .AND. lwp )   WRITE(numout,*) ' ==>> time-step= ',kt,' SSS min:', zsmin
+      !
+      IF( zsmin < 0.) THEN 
+         IF (lk_mpp) THEN
+            CALL mpp_minloc ( tsn(:,:,1,jp_sal),tmask(:,:,1), zsmin, ii,ij )
+         ELSE
+            ilocs = MINLOC( tsn(:,:,1,jp_sal), mask = tmask(:,:,1) == 1.e0 )
+            ii = ilocs(1) + nimpp - 1
+            ij = ilocs(2) + njmpp - 1
+         ENDIF
+         !
+         IF(lwp) THEN
+            WRITE(numout,cform_err)
+            WRITE(numout,*) 'stp_ctl : NEGATIVE sea surface salinity'
+            WRITE(numout,*) '======= '
+            WRITE(numout,9500) kt, zsmin, ii, ij
+            WRITE(numout,*)
+            WRITE(numout,*) '          output of last fields in numwso'
+         ENDIF
+         kindic = -3
+      ENDIF
+9500  FORMAT (' kt=',i6,' min SSS: ',1pg11.4,', i j: ',2i5)
+      !
+      !
+      IF( lk_c1d )  RETURN          ! No log file in case of 1D vertical configuration
+
+      ! log file (ssh statistics)
+      ! --------                                   !* ssh statistics (and others...)
+      IF( kt == nit000 .AND. lwp ) THEN   ! open ssh statistics file (put in solver.stat file)
+         CALL ctl_opn( numsol, 'solver.stat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp, narea )
+      ENDIF
+      !
+      zsshmax = 0.e0
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+!            IF( (ln_wd .OR. ln_rwd)) THEN
+!               IF( tmask(ji,jj,1) == 1) zsshmax = MAX( zsshmax, ABS(sshn(ji,jj)+rn_ssh_ref) )
+!            ELSE
+               IF( tmask(ji,jj,1) == 1) zsshmax = MAX( zsshmax, ABS(sshn(ji,jj)) )
+!            ENDIF
+         END DO
+      END DO
+      IF( lk_mpp )   CALL mpp_max( zsshmax )                ! min over the global domain
+      !
+      IF( MOD( kt, nwrite ) == 1 .AND. lwp )   WRITE(numout,*) ' ==>> time-step= ',kt,' ssh max:', zsshmax
+      !
+      IF( zsshmax > 10.e0 ) THEN 
+         IF (lk_mpp) THEN
+            CALL mpp_maxloc( ABS(sshn(:,:)),tmask(:,:,1),zsshmax,ii,ij)
+         ELSE
+            ilocs = MAXLOC( ABS(sshn(:,:)) )
+            ii = ilocs(1) + nimpp - 1
+            ij = ilocs(2) + njmpp - 1
+         ENDIF
+         !
+         IF(lwp) THEN
+            WRITE(numout,cform_err)
+            WRITE(numout,*) 'stp_ctl : the ssh is larger than 10m'
+            WRITE(numout,*) '======= '
+            WRITE(numout,9600) kt, zsshmax, ii, ij
+            WRITE(numout,*)
+            WRITE(numout,*) '          output of last fields in numwso'
+         ENDIF
+         kindic = -3
+      ENDIF
+9600  FORMAT (' kt=',i6,' max ssh: ',1pg11.4,', i j: ',2i5)
+      !
+      zssh2 = glob_sum( sshn(:,:) * sshn(:,:) )
+      !
+      IF(lwp) WRITE(numsol,9700) kt, zssh2, zumax, zsmin      ! ssh statistics
+      !
+9700  FORMAT(' it :', i8, ' ssh2: ', d23.16, ' Umax: ',d23.16,' Smin: ',d23.16)
+      !
+   END SUBROUTINE stp_ctl
+
+   !!======================================================================
+END MODULE stpctl
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/usrdef_zgr.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/usrdef_zgr.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/usrdef_zgr.F90	(revision 8865)
@@ -16,8 +16,8 @@
    USE oce            ! ocean variables
    USE dom_oce ,  ONLY: ln_zco, ln_zps, ln_sco   ! ocean space and time domain
-   USE dom_oce ,  ONLY: mi0, mi1, nimpp, njmpp,  &
-                      & mj0, mj1, glamt, gphit   ! ocean space and time domain
+   USE dom_oce ,  ONLY: ht_0,mi0, mi1, nimpp, njmpp,  &
+                      & mj0, mj1, glamt, gphit, ht_0   ! ocean space and time domain
    USE usrdef_nam     ! User defined : namelist variables
-   USE wet_dry ,  ONLY: rn_wdmin1, rn_wdmin2, rn_wdld, ht_wd, rn_ht_0,rn_ssh_ref
+   USE wet_dry ,  ONLY: rn_wdmin1, rn_wdmin2, rn_wdld,  rn_ht_0,rn_ssh_ref
    !
    USE in_out_manager ! I/O manager
@@ -234,5 +234,6 @@
               
 ! increase the depth of the bathymetry by rn_ssh_ref and rn_ht_0   
-      zht(:,:) = zht(:,:) + rn_ssh_ref + rn_ht_0  
+      !zht(:,:) = zht(:,:) + rn_ssh_ref + rn_ht_0  
+      !zht(:,:) = zht(:,:) + rn_ssh_ref + rn_ht_0  
 
       ! at u-point: averaging zht
@@ -285,5 +286,5 @@
       IF ( ln_sco ) THEN      !==  s-coordinate  ==!   (terrain-following coordinate)
          !
-         ht_wd = zht
+         ht_0 = zht
          k_bot(:,:) = jpkm1 * k_top(:,:)  !* bottom ocean = jpk-1 (here use k_top as a land mask)
          DO jj = 1, jpj
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90	(revision 8865)
@@ -21,4 +21,5 @@
    USE phycst          ! physical constants
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE wet_dry         ! Use wet dry to get reference ssh level
    USE in_out_manager  !
 
@@ -169,5 +170,9 @@
          ii = idx%nbi(jb,igrd)
          ij = idx%nbj(jb,igrd)
-         spgu(ii, ij) = dta%ssh(jb)
+         IF( ln_wd .OR. ln_rwd ) THEN
+            spgu(ii, ij) = dta%ssh(jb)  - rn_ssh_ref 
+         ELSE
+            spgu(ii, ij) = dta%ssh(jb)
+         ENDIF
       END DO
 
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 8865)
@@ -154,7 +154,12 @@
          CALL iom_put( "e3tdef"  , ( ( e3t_n(:,:,:) - e3t_0(:,:,:) ) / e3t_0(:,:,:) * 100 * tmask(:,:,:) ) ** 2 )
 
-      CALL iom_put( "ssh" , sshn )                 ! sea surface height
+      IF( (ln_wd .OR. ln_rwd)) THEN
+         CALL iom_put( "ssh" , sshn+rn_ssh_ref )                 ! sea surface height !bring it back to the reference need wad if here
+      ELSE
+         CALL iom_put( "ssh" , sshn )                 ! sea surface height !bring it back to the reference need wad if here
+      ENDIF
+
       IF( iom_use("wetdep") )   &                  ! wet depth
-         CALL iom_put( "wetdep" , ht_wd(:,:) + sshn(:,:) )
+         CALL iom_put( "wetdep" , ht_0(:,:) + sshn(:,:) )
       
       CALL iom_put( "toce", tsn(:,:,:,jp_tem) )    ! 3D temperature
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 8865)
@@ -674,7 +674,6 @@
       ENDIF
       !
-      IF( ln_wd ) THEN              ! wetting and drying domain
+      IF( ln_wd  .or. ln_rwd ) THEN              ! wetting and drying domain
          CALL iom_rstput( 0, 0, inum, 'ht_0'   , ht_0   , ktype = jp_r8 )
-         CALL iom_rstput( 0, 0, inum, 'ht_wd'  , ht_wd  , ktype = jp_r8 )
       ENDIF
       !
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 8865)
@@ -876,37 +876,48 @@
          ELSE                                   !* Initialize at "rest"
             !
-            IF( ln_wd .AND. ( cn_cfg == 'wad' ) ) THEN
+
+! MJB ln_rwd edits start here - these are essential 
+
+            IF( (ln_wd .OR. ln_rwd)) THEN 
+
               ! Wetting and drying test case
-              CALL usr_def_istate( gdept_b, tmask, tsb, ub, vb, sshb  )
-                       tsn  (:,:,:,:) = tsb (:,:,:,:)       ! set now values from to before ones
-                       sshn (:,:)     = sshb(:,:)
-                       un   (:,:,:)   = ub  (:,:,:)
-                       vn   (:,:,:)   = vb  (:,:,:)
-                                                ! uniform T-S fields and initial ssh slope
-               ! needs to be called here and in istate which is called later.
-               ! Adjust vertical metrics
+               IF( cn_cfg == 'wad' ) THEN
+                  CALL usr_def_istate( gdept_b, tmask, tsb, ub, vb, sshb  )
+                  tsn  (:,:,:,:) = tsb (:,:,:,:)       ! set now values from to before ones
+                  sshn (:,:)     = sshb(:,:)
+                  un   (:,:,:)   = ub  (:,:,:)
+                  vn   (:,:,:)   = vb  (:,:,:)
+               ELSEIF( ln_wd .or. ln_rwd   ) THEN ! if not test case
+                  sshn(:,:) = -rn_ssh_ref
+                  sshb(:,:) = -rn_ssh_ref
+
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        IF( ht_0(ji,jj)-rn_ssh_ref <  rn_wdmin1 ) THEN ! if total depth is less than min depth
+
+                           sshb(ji,jj) = rn_wdmin1 - (ht_0(ji,jj) )
+                           sshn(ji,jj) = rn_wdmin1 - (ht_0(ji,jj) )
+                           ssha(ji,jj) = rn_wdmin1 - (ht_0(ji,jj) )
+                        ENDIF
+                     ENDDO
+                  ENDDO
+               ENDIF !If wad elseif ln_wd or ln_rwd
+
+               ! Adjust vertical metrics for all wad
                DO jk = 1, jpk
-                  e3t_n(:,:,jk) =  e3t_0(:,:,jk) * ( ht_0(:,:) + sshn(:,:) ) &
-                    &                            / ( ht_0(:,:) + 1._wp - ssmask(:,:) ) * tmask(:,:,jk)   &
-                    &            + e3t_0(:,:,jk)                               * (1._wp -tmask(:,:,jk))
+                    e3t_n(:,:,jk) =  e3t_0(:,:,jk) * ( ht_0(:,:) - rn_ht_0 + sshn(:,:)  ) &
+                      &                            / ( ht_0(:,:) + 1._wp - ssmask(:,:) ) * tmask(:,:,jk)   &
+                      &            + e3t_0(:,:,jk)                               * (1._wp -tmask(:,:,jk))
                END DO
                e3t_b(:,:,:) = e3t_n(:,:,:)
-               !
-            ELSEIF( ln_wd ) THEN
-               !
-              DO jj = 1, jpj
-                DO ji = 1, jpi
-                  IF( e3t_0(ji,jj,1) <= 0.5_wp * rn_wdmin1 ) THEN
-                     ! potential bug
-                     ! Warning this assumes 2 layers only over wetting locations. needs investigating
-                     e3t_b(ji,jj,:) = 0.5_wp * rn_wdmin1
-                     e3t_n(ji,jj,:) = 0.5_wp * rn_wdmin1
-                     e3t_a(ji,jj,:) = 0.5_wp * rn_wdmin1
-                     sshb(ji,jj) = rn_wdmin1 - ht_wd(ji,jj)           !!gm I don't understand that !
-                     sshn(ji,jj) = rn_wdmin1 - ht_wd(ji,jj)
-                     ssha(ji,jj) = rn_wdmin1 - ht_wd(ji,jj)
-                  ENDIF
-                ENDDO
-              ENDDO
+
+               DO ji = 1, jpi
+                  DO jj = 1, jpj
+                     IF ( ht_0(ji,jj) .LE. 0.0 .AND. NINT(ssmask(ji,jj)) .EQ. 1) THEN
+                       CALL ctl_stop( 'dom_vvl_rst: ht_0 must be positive at potentially wet points' )
+                     ENDIF
+                  END DO 
+               END DO 
+ 
                !
             ELSE
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 8865)
@@ -18,5 +18,5 @@
    USE dom_oce         ! ocean space and time domain
    USE phycst ,   ONLY :   rsmall
-   USE wet_dry,   ONLY :   ln_wd, ht_wd
+   USE wet_dry,   ONLY :   ln_wd, ln_rwd
    !
    USE in_out_manager  ! I/O manager
@@ -198,8 +198,6 @@
       ENDIF
       !
-      IF( ln_wd ) THEN                                          ! wetting and drying domain
-         CALL iom_rstput( 0, 0, inum, 'ht_0'   , ht_0   , ktype = jp_r8 )
-         CALL iom_rstput( 0, 0, inum, 'ht_wd'  , ht_wd  , ktype = jp_r8 )
-      ENDIF
+      IF( ln_wd .OR. ln_rwd ) CALL iom_rstput( 0, 0, inum, 'ht_0'   , ht_0   , ktype = jp_r8 )
+
       !                                     ! ============================
       CALL iom_close( inum )                !        close the files 
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 8865)
@@ -30,5 +30,5 @@
    USE usrdef_zgr     ! user defined vertical coordinate system
    USE depth_e3       ! depth <=> e3
-   USE wet_dry, ONLY: ln_wd, ht_wd
+   USE wet_dry, ONLY: ln_wd, ln_rwd, rn_ssh_ref
    !
    USE in_out_manager ! I/O manager
@@ -258,6 +258,6 @@
       k_bot(:,:) = INT( z2d(:,:) )
       !
-      ! bathymetry with orography (wetting and drying only)
-      IF( ln_wd )  CALL iom_get( inum, jpdom_data, 'ht_wd' , ht_wd  , lrowattr=ln_use_jattr )
+      ! reference depth for negative bathy (wetting and drying only)
+      IF( ln_wd .OR. ln_rwd )  CALL iom_get( inum,  'rn_wd_ref_depth' , rn_ssh_ref   )
       !
       CALL iom_close( inum )
